
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Scala入门到精通——第三十节 Scala脚本编程与结束语 / iVAN</title>

    <meta name="description" content="Scala入门到精通——第三十节 Scala脚本编程与结束语 本节主要内容 REPL命令行高级使用 使用Scala进行Linux脚本编程 结束语 1. REPL命令行高级使用 在使用REPL命令行时,有时候我们需要粘贴的代码比较大,而普通的粘贴可能会些一些问题,比如中文粘贴会出现乱码.多行代码粘贴时会出错,此时需要用到REPL的高级功能.在日常开发过程中,我们粘贴多行代码的时候会遇到下列问题: //本意是要粘贴下面两行代码 class Person(val name:String,val age:Int) val p=new Person(&quot;摇摆 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">Scala入门到精通——第三十节 Scala脚本编程与结束语</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>本节主要内容</h2>
<ol>
<li>REPL命令行高级使用</li>
<li>使用Scala进行Linux脚本编程</li>
<li>结束语</li>
</ol>
<h2>1. REPL命令行高级使用</h2>
<p>在使用REPL命令行时，有时候我们需要粘贴的代码比较大，而普通的粘贴可能会些一些问题，比如中文粘贴会出现乱码、多行代码粘贴时会出错，此时需要用到REPL的高级功能。在日常开发过程中，我们粘贴多行代码的时候会遇到下列问题：</p>
<pre><code>//本意是要粘贴下面两行代码
class Person(val name:String,val age:Int)
val p=new Person("摇摆少年梦",27)

//直接在REPL命令行粘贴的话，会出现下面情况
//1 不会一次性粘入，而是分作两行
//2 中文出现乱码
scala&gt; class Person(val name:String,val age:Int)
defined class Person

scala&gt; val p=new Person("??????????",27)
p: Person = Person@cf528</code></pre>
<p>而对于一些长串跨行的代码，可能会出现报错，例如：</p>
<pre><code>//本意是要粘贴下面的代码
if(p.age&gt;10)
    true
  else
    false

//但实际情况是这样的
scala&gt; if(p.age&gt;10)
     |     true
res0: AnyVal = true

scala&gt;   else
&lt;console&gt;:1: error: illegal start of definition
         else
         ^

scala&gt;     false</code></pre>
<p>那要怎么办呢？在REPL命令行中执行下列命令：</p>
<pre><code>scala&gt; :paste
// Entering paste mode (ctrl-D to finish)

if(p.age&gt;10)
    true
  else
    false

// Exiting paste mode, now interpreting.

res3: Boolean = true</code></pre>
<p>先输入:paste，然后按ctr+v键，可以正常粘贴内容，中文也不会出现乱码了：</p>
<pre><code>scala&gt; :paste
// Entering paste mode (ctrl-D to finish)

class Person(val name:String,val age:Int)
val p=new Person("摇摆少年梦",27)

// Exiting paste mode, now interpreting.

defined class Person
p: Person = Person@1924b38</code></pre>
<p>另外，在实际开发过程中，有些人会认为这种处理方式非常繁琐，Scala的创建者也为我们考虑过这个问题了，我们也可以在scala IDE for eclipse （在Intellij IDEA 中也有这个功能） 里面利用REPL命令行，使用方式是创建scala worksheet，创建方式如下： <br />
1 点击相应的包，然后右键，在new菜单中选择 scala worksheet <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA4MTcxNjE1MTIyODY=.jpg"></p>
<p>2 在文件中输入相应的scala语句，worksheet会自动打印出相应的结果 <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA4MTcxNjE5NTgzNzU=.jpg"></p>
<p>但是worksheet对中文的支持很不友好，例如下面的代码：</p>
<pre><code>case class Person(val name:String,val age:Int)

object ScalaREPL {
  println("Scala worksheet")                      //&gt; Scala worksheet
  val p=new Person("摇摆少年梦",27)                    //&gt; p  : cn.scala.xtwy.jdbc.Person = Person(鎽囨憜灏戝勾姊�27)
}</code></pre>
<p>worksheet最终得到的中文是乱码，因此在实际进行语言特性测试的时候尽量避免中文</p>
<p>scala中还有很多我们实际中没有接触过的命令，可以用 :help命令查看REPL现在支持的所有命令：</p>
<pre><code>scala&gt; :help
All commands can be abbreviated, e.g. :he instead of :help.
Those marked with a * have more detailed help, e.g. :help imports.

:cp &lt;path&gt;                 add a jar or directory to the classpath
:help [command]            print this summary or command-specific help
:history [num]             show the history (optional num is commands to show)
:h? &lt;string&gt;               search the history
:imports [name name ...]   show import history, identifying sources of names
:implicits [-v]            show the implicits in scope
:javap &lt;path|class&gt;        disassemble a file or class name
:load &lt;path&gt;               load and interpret a Scala file
:paste                     enter paste mode: all input up to ctrl-D compiled tog
ether
:power                     enable power user mode
:quit                      exit the interpreter
:replay                    reset execution and replay all previous commands
:reset                     reset the repl to its initial state, forgetting all s
ession entries
:sh &lt;command line&gt;         run a shell command (result is implicitly =&gt; List[Str
ing])
:silent                    disable/enable automatic printing of results
:type [-v] &lt;expr&gt;          display the type of an expression without evaluating
it
:warnings                  show the suppressed warnings from the most recent lin
e which had any</code></pre>
<h2>2. 使用Scala进行Linux脚本编程</h2>
<p>本节Linux脚本内容大部分来源于scala cookbook，部分经过本人修改以在Ubuntu Linux上进行演示。</p>
<p>我们在第一节中提到，Scala不仅仅可以进行大规模分布式应用程序开发（例如Spark内存计算框架），也可以进行服务器端脚本编程即它可以替代Linux中的shell (Bourne Shell, Bash)或其它如 Perl, PHP, Ruby等可用于服务器端脚本编程的语言。下面给出的是一个简单示例（前提是要有linux操作系统，本节所有示例都是在ubuntu Linux下运行的）：</p>
<pre><code>#!/bin/sh
exec scala "$0" "$@"
!#
println("HellO,Linux World")</code></pre>
<p>将上面的内容保存为hello.sh文件，然后用下列命令增加其执行权限：</p>
<pre><code>root@sparkmaster:/home/zhouzhihu/scalaLearning# chmod +x hello.sh
root@sparkmaster:/home/zhouzhihu/scalaLearning# ./hello.sh
HellO,Linux World</code></pre>
<p>可以看到我们第一个服务器脚本已经运行成功。前面的代码中,#!符号表示的是Unix shell脚本的开始，它会调用Unix Bourne shell。exce命令是内置的shell，表示需要执行scala 命令，其中0绑定的是hello.sh脚本名称，@ 绑定的是我们输入的参数。!#表示脚本声明头部的结束。在脚本中可以使用任何的scala语法，例如：</p>
<pre><code>#!/bin/sh
exec scala "$0" "$@"
!#

class Person(val firstName:String,val secondName:String){
  override toString()="firstName:"+firstName+",secondName:"+secondName
}

println(new Person("john","Barake"))
</code></pre>
<p>上述代码执行结果：</p>
<pre><code>root@sparkmaster:/home/zhouzhihu/scalaLearning# ./person.sh
firstName:john,secondName:Barake
</code></pre>
<p>除此之外，我们还可以定义应用程序对象，可以扩展自App，也可以实现自己的Main方法，例如：</p>
<pre><code>#!/bin/sh
exec scala "$0" "$@"
!#
object Hello extends App {
println("Hello Ubuntu Linux 10.04")
//如果后面带参数的话，可以捕获所有的参数
args.foreach(println)
}
Hello.main(args)</code></pre>
<p>下面给出的是不带参数的执行结果：</p>
<pre><code>root@sparkmaster:/home/zhouzhihu/scalaLearning# ./HelloApp.sh
Hello Ubuntu Linux 10.04
</code></pre>
<p>下面给出的是带参数的执行结果，如：</p>
<pre><code>root@sparkmaster:/home/zhouzhihu/scalaLearning# ./HelloApp.sh hello xuetuwuyou

Hello Ubuntu Linux 10.04
hello
xuetuwuyou
</code></pre>
<p>当然，还可以实现自己的main方法，如：</p>
<pre><code>#!/bin/sh
exec scala "$0" "$@"
!#
object Hello {
  def main(args: Array[String]) {
    println("Hello, world")
    args.foreach(println)
  }
}
Hello.main(args)</code></pre>
<p>同extends App是一样的。</p>
<p>如果脚本中需要应用到第三方库的话，可以采用下列方式进行包引入：</p>
<pre><code>#!/bin/sh
exec scala -classpath "lib/slick_2.11_2.1.0.jar:lib/mysql-connector-java-5.1.18-bin.jar" "$0" "$@"
!#

import scala.slick.driver.MySQLDriver.simple._

object CoffeeExample extends App {

  class Suppliers(tag: Tag) extends Table[(Int, String, String, String, String, String)](tag, "SUPPLIERS") {
    def id = column[Int]("SUP_ID", O.PrimaryKey) // This is the primary key column
    def name = column[String]("SUP_NAME")
    def street = column[String]("STREET")
    def city = column[String]("CITY")
    def state = column[String]("STATE")
    def zip = column[String]("ZIP")
    // Every table needs a * projection with the same type as the table's type parameter
    def * = (id, name, street, city, state, zip)
  }
  val suppliers = TableQuery[Suppliers]

  // Definition of the COFFEES table
  class Coffees(tag: Tag) extends Table[(String, Int, Double, Int, Int)](tag, "COFFEES") {
    def name = column[String]("COF_NAME", O.PrimaryKey)
    def supID = column[Int]("SUP_ID")
    def price = column[Double]("PRICE")
    def sales = column[Int]("SALES")
    def total = column[Int]("TOTAL")
    def * = (name, supID, price, sales, total)
    // A reified foreign key relation that can be navigated to create a join
    def supplier = foreignKey("SUP_FK", supID, suppliers)(_.id)
  }
  val coffees = TableQuery[Coffees]

  Database.forURL("jdbc:mysql://localhost:3306/slick", "root", "123",
    driver = "com.mysql.jdbc.Driver") withSession {

      implicit session =&gt;
        // Create the tables, including primary and foreign keys
        (suppliers.ddl ++ coffees.ddl).create

        // Insert some suppliers
        suppliers += (101, "Acme, Inc.", "99 Market Street", "Groundsville", "CA", "95199")
        suppliers += (49, "Superior Coffee", "1 Party Place", "Mendocino", "CA", "95460")
        suppliers += (150, "The High Ground", "100 Coffee Lane", "Meadows", "CA", "93966")

        // Insert some coffees (using JDBC's batch insert feature, if supported by the DB)
        coffees ++= Seq(
          ("Colombian", 101, 7.99, 0, 0),
          ("French_Roast", 49, 8.99, 0, 0),
          ("Espresso", 150, 9.99, 0, 0),
          ("Colombian_Decaf", 101, 8.99, 0, 0),
          ("French_Roast_Decaf", 49, 9.99, 0, 0))

        coffees foreach {
          case (name, supID, price, sales, total) =&gt;
            println("  " + name + "\t" + supID + "\t" + price + "\t" + sales + "\t" + total)

        }
        val q1 = for (c &lt;- coffees)
          yield LiteralColumn("  ") ++ c.name ++ "\t" ++ c.supID.asColumnOf[String] ++
          "\t" ++ c.price.asColumnOf[String] ++ "\t" ++ c.sales.asColumnOf[String] ++
          "\t" ++ c.total.asColumnOf[String]
        // The first string constant needs to be lifted manually to a LiteralColumn
        // so that the proper ++ operator is found
        q1 foreach println

        // Perform a join to retrieve coffee names and supplier names for
        // all coffees costing less than $9.00
        val q2 = for {
          c &lt;- coffees if c.price &lt; 9.0
          s &lt;- suppliers if s.id === c.supID
        } yield (c.name, s.name)

    }

}
//这点与一般的应用程序不同
CoffeeExample.main(args)</code></pre>
<p>通过上述代码不难发现，脚本编程与一般的Scala应用程序开发有着非常多的相似之处，不同之处仅在于在脚本编程需要加入下面这样的样板代码</p>
<pre><code>#!/bin/sh  //样板代码
exec scala -classpath "lib/slick_2.11_2.1.0.jar:lib/mysql-connector-java-5.1.18-bin.jar" "$0" "$@"
!# //样板代码

....................

CoffeeExample.main(args) //样板代码</code></pre>
<p>有时候，我们也需要对命令行参数进行捕获（例如判断命令行的个数或输入的参数类型等），然后进行相应的操作，前面已经演示了如何打印输出命令行参数，这里我们更多实际中可能会遇到的一些经典案例： <br />
1 判断输入参数的个数，不满足要求则给出提示</p>
<pre><code>#!/bin/sh
exec scala "$0" "$@"
!#
if (args.length != 2) {
    Console.err.println("Usage: replacer &lt;search&gt; &lt;replace&gt;")
    System.exit(1)
}
val searchPattern = args(0)
val replacePattern = args(1)
println(s"Replacing $searchPattern with $replacePattern ...")</code></pre>
<p>执行结果如下：</p>
<pre><code>root@sparkmaster:/home/zhouzhihu/scalaLearning# ./argsNumberDemo.sh xuetuwu xuetuwuyou
Replacing xuetuwu with xuetuwuyou ...
root@sparkmaster:/home/zhouzhihu/scalaLearning# ./argsNumberDemo.sh
Usage: replacer &lt;search&gt; &lt;replace&gt;
</code></pre>
<p>2 交互式命令行，提示用户输入</p>
<pre><code>#!/bin/sh
exec scala "$0" "$@"
!#
// write some text out to the user with Console.println
Console.println("Hello")
// Console is imported by default, so it's not really needed, just use println
println("World")
// readLine lets you prompt the user and read their input as a String
val name = readLine("What's your name? ")
// readInt lets you read an Int, but you have to prompt the user manually
print("How old are you? ")
val age = readInt()
// you can also print output with printf
println(s"Your name is $name and you are $age years old.")</code></pre>
<p>下面给出的是其执行结果：</p>
<pre><code>root@sparkmaster:/home/zhouzhihu/scalaLearning# ./promptDemo.sh
Hello
World
What's your name? yaobaishaonianmeng
How old are you? 27
Your name is yaobaishaonianmeng and you are 27 years old.
</code></pre>
<p>3  加速代码的执行： <br />
scala脚本在执行的过程中，也是通过编译、执行的步骤来进行的，有时候为加速脚本的执行，意图是将编译后的脚本保存下来，在执行时候如果脚本创建之后没有发生变化的话，则直接使用以前编译好的脚本。实现方式是在脚本声明的时候用-savecompiled。</p>
<pre><code>#!/bin/sh
exec scala -savecompiled "$0" "$@"
!#
println("Hello, world!")
args foreach println</code></pre>
<p>它的原理是在代码第一次执行后，生成相应的jar文件，当下次再执行的便调用该jar文件来执行，第一次执行后生成的jar文件如下： <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA4MTcxNTQzMzA1NzI=.jpg"></p>
<h2>3. 结束语</h2>
<p>本节内容是scala入门到精通系列课程的最后一节，通过本课程，我相信可以让大家成为一个中级scala语言开发者。Scala语言功能非常强大，其中内容还有很多，还有许多内容我们没有涉及，例如scala 的GUI编程、Scala的定界延续等，但这些功能在实际开发中应用的并不是特别广泛，特别是Scala GUI编程，我们知道java在GUI编程方面并不是它的强项，scala语言也是如此。这门课程的目的是让大家学完之后能够快速上手spark应用程序开发，希望在学完本课程之后，大家将这门课作为自己学习scala的起点，而非终点。</p>
<p>作为本门课程的授课人，这也不是我的终点，而是我的起点，在后面我会接着对scala语言、Spark大数据处理技术进行更深入的学习和研究，并将自己的学习心得与体会分享给大家。在后面我将陆续开设下列几门课程：</p>
<pre><code>Spark修炼之道（基础篇）——Linux基础（12讲）、Akka分布式编程（8讲）
Spark修炼之道（进阶篇）——Spark入门到精通（30讲）
Spark修炼之道（实战篇）——Spark应用开发实战篇（20讲）
Spark修炼之道（高级篇）——Spark源码解析（50讲）</code></pre>
<p>该课程针对没有基础的朋友，从Linux开始讲起，然后介绍Akka框架如何进行分布式编程，再此基础上对Spark进行介绍。（基础篇）、（进阶篇）、（实战篇）及（高级篇）采用的是并发方式编写(^-^)，希望想学习大数据处理技术的朋友可以关注我的博客或微信公众号。</p>
<p>添加公众微信号，可以了解更多最新Spark、Scala相关技术资讯  <br /><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA3MTkxNDM2NTg2MzU=.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 06:51:04</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar">

		<h3>Scala入门到精通——第三十节 Scala脚本编程与结束语的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/baBr2JM.html" rel="bookmark">Spark修炼之道（进阶篇）&mdash;&mdash;Spark入门到精通：第十节 Spark Streaming（一&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节主要内容 本节部分内容来自官方文档:http://spark.apache.org/docs/latest/streaming-programming-guide.html#mllib-operations Spark流式计算简介 Spark Streaming相关核心类 入门案例 1. Spark流式计算简介 Hadoop的MapReduce及Spark SQL等只能进行离线计算,无法满足实时性要求较高的业务需求,例如实时推荐.实时网站性能分析等,流式计算可以解决这些问题.目前有三种比较常			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mx0B6PM.html" rel="bookmark">Spark修炼之道（进阶篇）&mdash;&mdash;Spark入门到精通：第十节 Spark SQL案例实战（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:周志湖 放假了,终于能抽出时间更新博客了--. 1. 获取数据 本文通过将github上的Spark项目git日志作为数据,对SparkSQL的内容进行详细介绍 数据获取命令如下: [root@master spark]# git log --pretty=format:'{&quot;commit&quot;:&quot;%H&quot;,&quot;author&quot;:&quot;%an&quot;,&quot;author_email&quot;:&quot;%ae&quot;,&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrX07Wz.html" rel="bookmark">Scala入门到精通&mdash;&mdash;第二十四节 高级类型 （三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				作者:摆摆少年梦 视频地址:http://blog.csdn.net/wsscy2004/article/details/38440247 本节主要内容 Type Specialization Manifest.TypeTag.ClassTag Scala类型系统总结 在scala中,类(class)与类型(type)是两个不一样的概念.我们知道类是对同一类型数据的抽象,而类型则更具体.比如定义class List[T] {}, 可以有List[Int] 和 List[String]等具体类型,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/boKYk3b.html" rel="bookmark">Scala入门到精通&mdash;&mdash;第十四节 Case Class与模式匹配（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节主要内容 模式匹配入门 Case Class简介 Case Class进阶 1. 模式匹配入门 在java语言中存在switch语句,例如: //下面的代码演示了java中switch语句的使用 public class SwitchDemo { public static void main(String[] args) { for(int i = 0; i &lt; 100; i++) { switch (i) { case 10:System.out.println(&quot;10&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bB1ngJz.html" rel="bookmark">Scala入门到精通&mdash;&mdash;第十六节 泛型与注解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节主要内容 泛型(Generic Type)简介 注解(Annotation)简介 注解常用场景 1. 泛型(Generic Type)简介 泛型用于指定方法或类可以接受任意类型参数,参数在实际使用时才被确定,泛型可以有效地增强程序的适用性,使用泛型可以使得类或方法具有更强的通用性.泛型的典型应用场景是集合及集合中的方法参数,可以说同java一样,scala中泛型无处不在,具体可以查看scala的api 1 泛型类 //单个泛型参数的使用情况 class Person[T](var name:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjoKq0M.html" rel="bookmark">Scala入门到精通&mdash;&mdash;第十节 Scala类层次结构、Traits初步</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节主要内容 Scala类层次结构总览 Scala中原生类型的实现方式解析 Nothing.Null类型解析 Traits简介 Traits几种不同使用方式 1 Scala类层次结构 Scala中的类层次结构图如下: 来源:Programming in Scala 从上面的类层次结构图中可以看到,处于继承层次最顶层的是Any类,它是scala继承的根类,scala中所有的类都是它的子类 Any类中定义了下面几个方法: //==与!=被声明为final,它们不能被子类重写 final def ==			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pm6avDz.html" rel="bookmark">Scala入门到精通&mdash;&mdash;第四节 Set、Map、Tuple、队列操作实战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节主要内容 mutable.immutable集合 Set操作实战 Map操作实战 Tuple操作实战 队列操作实战 栈操作实战 mutable.immutable集合 以下内容来源于scala官方文档: http://www.scala-lang.org/docu/files/collections-api/collections.html Scala collections systematically distinguish between mutable and immutable c			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pdREkNb.html" rel="bookmark">Scala入门到精通&mdash;&mdash; 第二节Scala基本类型及操作、程序控制结构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节主要内容 Scala基本类型 基本类型操作 Scala程序控制结构 Scala基本类型 Scala中的基本数据类型如下图: (来源:Programming in Scala) 从上表中可以看出,Scala的基本数据类型与Java中的基本数据类型是一一对应的,不同的是Scala的基本数据类型头字母必须大写,本节以Int.Long.String.Char.Double及Float类型为例介绍Scala的基本类型定义 整数类型变量定义: //16进制定义法 scala&gt; val x=0x29 x:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr3Rvmp.html" rel="bookmark">Scala入门到精通&mdash;&mdash;第七节：类和对象（二）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本节主要内容 单例对象 伴生对象与伴生类 apply方法 应用程序对象 抽象类 单例对象 在某些应用场景下,我们可能不需要创建对象,而是想直接调用方法,但是Scala语言并不支持静态成员,Scala通过单例对象来解决该问题.单例对象的创建方式如下: object Student { private var studentNo:Int=0; def uniqueStudentNo()={ studentNo+=1 studentNo } def main(args: Array[String]):			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMAAyeM.html" rel="bookmark" class="title">在Oracle中使用consistent gets的特例</a>
					<div>
						Oracle数据库中,consistent gets在判断一段SQL的性能时非常有用,通常来讲比较两段SQL的性 能好坏不是看谁的执行时间短,而是看谁的consistent gets小.不过这也不是绝 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qMqVWap.html" rel="bookmark" class="title">javascript函数库&colon;jQuery基础教程</a>
					<div>
						文章简介:jQuery是目前使用最广泛的javascript函数库.据统计,全世界排名前100万的网站,有46%使用jQuery,远远超过其他库.微软公司甚至把jQuery作为他们的官方库.对于网页开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/qbavKQM.html" rel="bookmark" class="title">PHP安全性漫谈</a>
					<div>
						本文所讨论的安全性环境是在Linux+Apache+Mysql+PHP.超出此范围的安全性问题不在本文范畴之内. 一.apache server安全性设置               1.以Nobod ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Vzwm15M.html" rel="bookmark" class="title">BT服务器架设全攻略&lpar;1&rpar;</a>
					<div>
						服务器|攻略 首先让我们了解BitTorrent服务器需要什么样的配置. 1.你需要一个配置比较高的服务器:PS:服务器的配置根据你网站的访问量不同而定,如果你网站已经有日5万以上的访问量最好使用P4 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6dOgz.html" rel="bookmark" class="title">用XML&plus;FSO&plus;JS实现服务器端文件</a>
					<div>
						fso|js|xml|服务器 首先在服务器端先创建一个程序可以生成XML文件,以返回客户端,(getfolder.asp)&lt;%'written by Linzhang Chen ,2003-4- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM10Aob.html" rel="bookmark" class="title">在DataSet中建立外键约束</a>
					<div>
						程序可以直接拿来使用,运行通过. ---------------------------------------------------- testconstraint.aspx ---------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/2MW9Q7z.html" rel="bookmark" class="title">关于变量数据类型的几点讨论&lpar;一&rpar;</a>
					<div>
						变量|数据|数据类型 variant变量的格式有OLE定义,可以存放任何类型的数据,并以下图的格式用16个字节存放某些变量. 0-1 2-7 8-15 varType Unused Value 第0和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM6ldAz.html" rel="bookmark" class="title">防范用135端口抓鸡的黑手</a>
					<div>
						新学期到了,许多学生都要配机,新电脑的安全防卫做好了吗?能不能拒绝成为黑客的肉鸡?令人遗憾的是,很多新手都不知道或者忽视了敏感端口的屏蔽,例如135端口,一旦黑客利用135端口进入你的电脑,就能成功地 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6Oygz.html" rel="bookmark" class="title">练习</a>
					<div>
						(1) 新建一个名为Gerbil的类,在构建器中初始化一个int gerbilNumber(类似本章的Mouse例子).为其写一个名为hop()的方法,用它打印出符合hop()条件的Gerbil的编号 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqLNPYb.html" rel="bookmark" class="title">使用光影魔术手批量去除水印的方法</a>
					<div>
						今天多特小编给大家介绍使用光影魔术手,给图片去除水印的方法,希望对大家有所帮助. 1.自动或批处理,预列了6个&quot;自动动作方案&quot;,我们通过&quot;文件&quot;的下拉菜单看到& ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze4YWwp.html" rel="bookmark" class="title">常见问题及对策之如何复制幻灯片</a>
					<div>
						有时候,我们需要借用已经制作好的一篇演示文稿中的某一张(或多张)幻灯片,我们如何将其复制过来呢? 解决方法:打开已经制作好的演示文稿,在右边的大纲区中,选中需要借用的幻灯片,执行&quot;复制&qu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7x5jM.html" rel="bookmark" class="title">WinXP如何删除系统中不想要的服务</a>
					<div>
						  一.进入&quot;服务管理&quot;界面: 1.通过右键单击&quot;我的电脑&quot;-&quot;管理&quot;-&quot;服务和应用程序&quot;-&quot;服务&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArlAJp.html" rel="bookmark" class="title">ps图片灰蒙蒙的怎么变清楚</a>
					<div>
						  这里简单的用到photoshop中调整阴影亮度,调整高光度,photoshopCC中还有&quot;反雾霾&quot;选项哦,然后用到调整色调曲线,合成等多个设置,具体photoshop风景后期处 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo7jaXb.html" rel="bookmark" class="title">如何修改win7资源管理器的默认启动位置</a>
					<div>
						  第一步.右键点击Windows资源管理器的图标,会弹出一个菜单. 第二步.再右键单击弹出菜单中的&quot;Windows资源管理器&quot;,单击属性. 第三步.修改Windows资源管理器的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnYP6jM.html" rel="bookmark" class="title">Win7系统下VHD文件是什么以及其有哪些类型</a>
					<div>
						  一.VHD文件的含义 VHD文件格式是一种虚拟机硬盘(virtual machine hard disk), 它可以被压缩成单个文件存放在宿主机器的文件系统上,主要包括虚拟机启动所需系统文件,在W ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq8yDkb.html" rel="bookmark" class="title">解决Win7提示配置Windows更新失败</a>
					<div>
						  1.点击桌面左下角&quot;Windows&quot;图标,然后点击&quot;运行&quot;,如下图所示: 2.在运行窗口输入&quot;msconfig&quot;指令,然后点击&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAr36Xp.html" rel="bookmark" class="title">亲，谁现在用android studio呢  这个问题何解，请问一下，拜托拜托！</a>
					<div>
						问题描述 亲,谁现在用android studio呢 这个问题何解,请问一下,拜托拜托! 解决方案 我是这样安装的,先安装android studio,SDK单独从网上下载,然后再选择本地的SDK路径 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5N9Dmz.html" rel="bookmark" class="title">html5-手机网页中，图片按钮自适应屏幕大小沉底</a>
					<div>
						问题描述 手机网页中,图片按钮自适应屏幕大小沉底 HTML5做手机网页,现在需要将一排4个按钮沉底,网页已经自适应屏幕大小宽和高都100%, 为什么我用百分比设置的时候,要达到百分之一百多,在苹果5, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9YdWkM.html" rel="bookmark" class="title">stringcopy 问题，下面情形，为什么用1可以，2却得不到返回值！</a>
					<div>
						问题描述 stringcopy 问题,下面情形,为什么用1可以,2却得不到返回值! char* Mystr(char* DestSrc,char* Str) { assert(DestSrc!=NUL ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE6wD6M.html" rel="bookmark" class="title">C&num; 正则表达式（备忘录）</a>
					<div>
						基本元字符 .     匹配任意单个字符 |     逻辑或操作 []    匹配字符集中的一个字符 [^]  对字符集求非 -     定义一个区间  \      对下一个字符转义  数量元字符  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWl13np.html" rel="bookmark" class="title">javascript-js 调试出现未定义或null引用的问题</a>
					<div>
						问题描述 js 调试出现未定义或null引用的问题 )SCRIPT5007: 无法获取未定义或 null 引用的属性&quot;0&quot; SCRIPT5022: InvalidStateErro ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdRqQ4b.html" rel="bookmark" class="title">阿里云欧洲数据中心开放运营：与沃达丰达成战略合作</a>
					<div>
						今天,阿里云在德国宣布正式登陆欧洲市场,其位于欧洲的数据中心正式开放运营,同时与沃达丰达成战略合作,携手为欧洲提供云计算服务,并为中国企业进入欧洲市场提供互联网基础设施便利. 据悉,这次新成立的数据中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6Z8AYM.html" rel="bookmark" class="title">一套漏洞一套房？ 这个让黑客动动鼠标就能赚170万美元的比赛叫做 PwnFest</a>
					<div>
						   这世界对手艺人往往很残酷. 例如,用葱油饼传承老上海味道的阿大,被一纸执照为难得几乎关张. 例如,在赛博世界如风穿行的黑客们,曾经非要抛弃道德底线才能致富. 然而世界也不算太坏.阿大成了网红,有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEKdqPp.html" rel="bookmark" class="title">学校网络推广主要是做什么&quest;</a>
					<div>
						培训学校的校长和我谈过之后,问我有没有兴趣到他的学校网络推广.这个一般工作是做什么?(需要外出的吗?)工资一般怎么样?都要熟悉哪些东西?(是现实中的培训学校,什么培训都有的) 网络推广不需要外出,主要 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyeAvvM.html" rel="bookmark" class="title">打印机有两个纸盒，怎样使用指定的纸盒打印</a>
					<div>
						问题描述 我的想法是这样的,用pringtDialog设置,this.printDialog1.ShowDialog(this).关闭printDialog1后,获得设置的papersource,th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M60DBJz.html" rel="bookmark" class="title">tomcat-求帮忙解决下Tomcat的OutOfMemoryError&colon; PermGen space问题</a>
					<div>
						问题描述 求帮忙解决下Tomcat的OutOfMemoryError: PermGen space问题 我用的是MyEclipse2014,tomcat是8.x的,困扰了很久了,下面是我的配置,但是好 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bBk6WaM.html" rel="bookmark" class="title">北京网吧要求上网者登记照片</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 从武汉来北京旅游的张丽红刚刚走进西 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MAklaez.html" rel="bookmark" class="title">给Javascript数组插入一条记录的代码&lowbar;javascript技巧</a>
					<div>
						&lt;script type=&quot;text/javascript&quot;&gt; Array.prototype.insert = function(vVal,nIdx) {   var ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyWOylz.html" rel="bookmark" class="title">页面中iframe相互传值传参&lowbar;javascript技巧</a>
					<div>
						一个页面,iframe了一个框架: parent.add_cart(); //子框架,可以访问父框架的函数 parent.frames[&quot;BoardList&quot;].document. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYxeAb.html" rel="bookmark" class="title">jquery&plus;正则实现统一的表单验证&lowbar;jquery</a>
					<div>
						表单验证一直很繁琐,特别是大点的表单,如果每个input都去单独写验证简直要写死人,最近写了一小段js统一的验证表单内容是否正确. 使用这段代码就不再需要对每个input写格式判断,只需要将正确格式的 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.036 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
